import time
import shared_simulated_state
import climate_chamber_dummy
import VNA_dummy


# A single global instance of the virtual clock is used and returned whenever cet_clock is called
virtual_clock_instance = None

# FIXME: This function has a bad signature because we are passing all the information needed to create the full
# simulation. Find a better way to instantiate the simulation and get the instances.


def get_clock(hostname, target_accuracy):
    global virtual_clock_instance
    if hostname == "localhost":
        # create a new clock only the first time a virtual clock is requested
        if virtual_clock_instance is None:
            virtual_clock_instance = VirtualClock(target_accuracy)
        return virtual_clock_instance
    else:
        return RealClock()


class VirtualClock:
    def __init__(self, target_accuracy):
        self.simulated_state = shared_simulated_state.get_simulated_state()
        self.climate_chamber_dummy = climate_chamber_dummy.get_climate_chamber_dummy(target_accuracy)
        self.VNA_dummy = VNA_dummy.get_vna_dummy(target_accuracy)

    def time(self):
        return self.simulated_state.simulated_time

    def sleep(self, sleep_time):
        self.simulated_state.simulated_time += sleep_time
        self.climate_chamber_dummy.run_simulation()
        self.VNA_dummy.run_simulation()


class RealClock:
    def time(self):
        return time.time()

    def sleep(self, sleep_time):
        time.sleep(sleep_time)
